package sinhalaocr;

class Line
{
	private int lineNo;
	private int lineStart,lineEnd,lineCentre,lineHeight,lineWidth;
	private int NumberOfCharacters;
	private int line_data[];
	private int char_start_info[],char_end_info[];
	private Char characters[];



	public Line (int line_no,int start,int end,int width){
		this.lineNo=line_no;
		this.lineStart=start;
		this.lineEnd=end;
		this.lineHeight=(end-start)+1;
		this.lineWidth=width;
		this.NumberOfCharacters=0;
	}
	public int getLineNo(){
		return this.lineNo;
	}
	public int getLineStart(){
		return this.lineStart;
	}
	public int getLineEnd(){
		return this.lineEnd;
	}
	public int getLineCentre(){
		this.lineCentre=(int)(this.lineEnd-this.lineStart)/2;
		return this.lineCentre;
	}
	public int[] getData(){
		return this.line_data;
	}
	public int getLineWidth(){
		return this.lineWidth;
	}
	public int getLineHeight(){
		return this.lineHeight;
	}
	public int getCharCount(){
	return this.calculateCharCount();
	}
	public int[] getCharStartInfo(){
		return this.char_start_info;
	}
	public int[] getCharEndInfo(){
		return this.char_end_info;
	}
	public Char[] getCharArray(){
		return this.characters;
	}
	public void setCharArray(){
		this.characters = new Char[this.getCharCount()];
		for(int i=0;i<this.characters.length;i++)
		this.characters[i]= new Char(i,this.char_start_info[i],this.char_end_info[i],this.lineStart,this.lineEnd);
	}
	public int calculateCharCount(){
	int charCount=0;
	boolean non_zero=false;
	int vp[]=this.verticalProjection();
	for(int i=0;i<vp.length;i++){
		if(vp[i]!=0)
		{
			if(non_zero==false)
			{
				non_zero=true;
				charCount++;
			}
		}
		if(vp[i]==0){
			if(non_zero==true){
				non_zero=false;

			}
		}

	}
		this.NumberOfCharacters=charCount;
		return charCount;
	}
	public int averageCharLength(){
	int vp[]=this.verticalProjection();
	this.char_start_info= new int[this.getCharCount()];
	this.char_end_info=new int[this.getCharCount()];
	int avgCharLength=0,char_start=0,char_end=0,no_of_chars=0,charSt=0,charEd=0;
	boolean non_zero=false;
	for(int i=0;i<vp.length;i++){
		if(vp[i]!=0){
		if(!non_zero)
		{
			non_zero=true;
			char_start=i;
			this.char_start_info[charSt++]=char_start;
		}
		}
		else
		{
			if(non_zero){
				non_zero=false;
				char_end=i-1;
				avgCharLength=avgCharLength+(char_end-char_start);
				this.char_end_info[charEd++]=char_end;
			}
		}
	}
	no_of_chars=this.calculateCharCount();
	return ((int)avgCharLength)/(int)no_of_chars;
	}
	public void extractPixelValues(int pixels[]){
		line_data=new int[this.lineHeight*this.lineWidth];
		int k=0;
		int lnStart=(this.lineStart*this.lineWidth);
		int lnEnd=this.lineEnd*(this.lineWidth);
		for(int i=lnStart;i<=lnEnd;i++){
			line_data[k++]=pixels[i];
		}
	}

	public int[] verticalProjection(){
		int vp[]= new int[this.lineWidth];
		int sum=0;
		for(int i=0;i<this.lineWidth;i++){
			for(int j=0;j<this.lineHeight-1;j++){
				if((this.line_data[j*this.lineWidth+i]&0xff)==0){
				sum++;
				}
		}
		vp[i]=sum;
		sum=0;
		}
		return this.removeVP(vp);
	}
        public int[] removeVP(int vpData[]){
                //for(int y=2;y<hpData.length-4;y++)
                 //  if((hpData[y-2]==0)&&(hpData[y-1]!=0)&&(hpData[y]!=0)&&(hpData[y+1]==0)){
                 //    hpData[y] = 0;
                  //   hpData[y-1] = 0;
                 //  }
                for(int y=1;y<vpData.length-1;y++)
                  if((vpData[y-1]==0)&&(vpData[y]!=0)&&(vpData[y+1]==0))
                    vpData[y]=0;
                  return vpData;
                }

	public void spaceInfo(){
	int vp[]=this.verticalProjection();

	}


}
